## rock-master-19.06-gui-osgviz 0.20190327

=== CMakeLists.txt ===
# CMakeLists.txt has to be located in the project folder and cmake has to be
# executed from 'project/build' with 'cmake ../'.
cmake_minimum_required(VERSION 2.6)
find_package(Rock)
rock_activate_cxx11()
rock_init(osgViz 0.1)
rock_standard_layout()

=== src/CMakeLists.txt ===


find_package(OpenSceneGraph REQUIRED osgManipulator osgViewer osgFX osgShadow osgParticle osgTerrain osgDB osgGA osgWidget osgText osgUtil)
include_directories(${OPENSCENEGRAPH_INCLUDE_DIRS})
link_directories(${OPENSCENEGRAPH_LIBRARY_DIRS})

find_package(Boost REQUIRED)
include_directories(${Boost_INCLUDE_DIRS})

include(CheckIncludeFileCXX)

set (CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${OPENSCENEGRAPH_INCLUDE_DIRS})
CHECK_INCLUDE_FILE_CXX("osg/Version" HAVE_OSG_VERSION_H)
if(${HAVE_OSG_VERSION_H})
    ADD_DEFINITIONS(-DHAVE_OSG_VERSION_H)
endif()

CHECK_INCLUDE_FILE_CXX("tr1/functional" USE_TR1)
if(${USE_TR1})
    ADD_DEFINITIONS(-DUSE_TR1)
else(${USE_TR1})
    ADD_DEFINITIONS(-DNO_TR1)
endif()

set(USE_MARS_VBO 0)
if(USE_MARS_VBO)
    ADD_DEFINITIONS(-DUSE_MARS_VBO)
endif()

if (UNIX)
	set(ADDITIONAL_LIBS X11)
endif (UNIX)

rock_library(osgVizInterfaces
	HEADERS interfaces/Clickable.h
			interfaces/WindowInterface.h
			interfaces/Updatable.h
			interfaces/MouseMoveCallback.h
      interfaces/WindowResizeCallback.h
	SOURCES Main.cpp
)


rock_library(osgVizGraphics
    SOURCES graphics/interfaces/data/GraphicData.cpp
            graphics/interfaces/data/LightData.cpp
            graphics/wrapper/OSGLightStruct.cpp
    HEADERS
            graphics/interfaces/OsgVizDefs.h
            graphics/interfaces/data/GraphicData.h
            graphics/interfaces/data/LightData.h
            graphics/wrapper/OSGLightStruct.h

    DEPS_PKGCONFIG openscenegraph)


rock_library(osgViz
    SOURCES OsgViz.cpp
           Object.cpp
           windows/Window.cpp
           windows/WindowManager.cpp
           windows/SuperView.cpp
           windows/HUD/HUD.cpp
           windows/HUD/HUDHoverScaler.cpp
           windows/HUD/HUDPositionChanger.cpp
           windows/EventHandlers/HierarchicalEventHandler.cpp
           windows/EventHandlers/ObjectSelector.cpp
           windows/EventHandlers/MouseMoveEvent.cpp
           windows/EventHandlers/WindowResizeEvent.cpp
           windows/CameraManipulator/TerrainZoomManipulator.cpp
           tools/UpdateThread.cpp    
           
    HEADERS OsgViz.hpp
           Object.h
           Module.h
           windows/Window.h
           windows/WindowManager.h
           windows/SuperView.h
           windows/HUD/HUD.h
           windows/HUD/HUDHoverScaler.h
           windows/HUD/HUDPositionChanger.h
           windows/EventHandlers/HierarchicalEventHandler.h
           windows/EventHandlers/ObjectSelector.h
           windows/EventHandlers/NullClickObject.h
           windows/EventHandlers/MouseMoveEvent.h
           windows/EventHandlers/WindowResizeEvent.h
           windows/config/WindowConfig.h
           windows/CameraManipulator/TerrainZoomManipulator.hpp
           tools/UpdateThread.h
           tools/Timing.h
           tools/TypeNameDemangling.h
           tools/GraphPrinter.h
           tools/SearchNodes.h
           tools/GlobalPos.h
               
    LIBS ${ADDITIONAL_LIBS}
    DEPS osgVizGraphics 
    DEPS_PKGCONFIG openscenegraph
)

rock_library(PrimitivesFactory
    SOURCES
    modules/viz/Primitives/PrimitivesFactory.cpp
    modules/viz/Primitives/Primitives/AxesNode.cpp
    modules/viz/Primitives/Primitives/GridNode.cpp
    modules/viz/Primitives/Primitives/ArrowNode.cpp
    modules/viz/Primitives/Primitives/WireframeBox.cpp
    modules/viz/Primitives/Primitives/LinesNode.cpp
    modules/viz/Primitives/Primitives/RingNode.cpp
    modules/viz/Primitives/Primitives/SphereNode.cpp
    modules/viz/Primitives/Primitives/TextNode.cpp
    modules/viz/Primitives/Primitives/Graph_2D.cpp

    HEADERS
    modules/viz/Primitives/PrimitivesFactory.h
    modules/viz/Primitives/Primitives/ArrowNode.h
    modules/viz/Primitives/Primitives/WireframeBox.hpp
    modules/viz/Primitives/Primitives/LinesNode.h
    modules/viz/Primitives/Primitives/RingNode.hpp
    modules/viz/Primitives/Primitives/SphereNode.hpp
    modules/viz/Primitives/Primitives/TextNode.hpp
    modules/viz/Primitives/Primitives/Graph_2D.hpp
    DEPS osgViz)

rock_library(ManipulationClickHandler
    SOURCES
    modules/ManipulationClickHandler/ManipulationClickHandler.cpp
    modules/ManipulationClickHandler/TranslateRotateDragger.cpp
    HEADERS
    modules/ManipulationClickHandler/ManipulationClickHandler.h
    modules/ManipulationClickHandler/TranslateRotateDragger.h
    DEPS osgViz PrimitivesFactory)

    

rock_library(ModelLoader
    SOURCES modules/viz/ModelLoader/ModelLoader.cpp
    HEADERS modules/viz/ModelLoader/ModelLoader.h
    DEPS osgViz)
    
rock_executable(osgViz_bin Main.cpp
    DEPS osgViz PrimitivesFactory ModelLoader
    LIBS ${ADDITIONAL_LIBS})

=== debian/changelog ===
rock-master-19.06-gui-osgviz (0.20190327-1~stretch) unstable; urgency=low

  * Package automatically built using 'apaka'
  * repository: github:/rock-core/gui-osgviz.git
  * branch: refs/heads/master
  * commit: 26c11534c84f257859af9a1db979fd9e0b333f5c
  * tag: 

 -- Packaging Daemon <rock-dev@dfki.de>  Mon, 08 Jul 2019 11:47:30 +0200

=== debian/control ===
Source: rock-master-19.06-gui-osgviz
Section: science
Priority: extra
Maintainer: Rock Packaging Daemon <rock-dev@dfki.de>
Build-Depends: cdbs, debhelper (>= 8.0.0), pkg-config, dh-autoreconf, build-essential, cmake, libboost-dev, libboost-filesystem-dev, libboost-graph-dev, libboost-iostreams-dev, libboost-program-options-dev, libboost-regex-dev, libboost-system-dev, libboost-thread-dev, libopenscenegraph-dev, rock-master-19.06-base-cmake
Standards-Version: 3.9.2
Homepage: http://rock-robotics.org
#Vcs-Git: git://git.debian.org/collab-maint/bla.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/bla.git;a=summary

Package: rock-master-19.06-gui-osgviz
Architecture: any
Depends: ${shlibs:Depends}, rock-master-19.06-base-cmake, cmake, build-essential, libopenscenegraph-dev, libboost-dev, libboost-graph-dev, libboost-program-options-dev, libboost-regex-dev, libboost-thread-dev, libboost-filesystem-dev, libboost-iostreams-dev, libboost-system-dev
Description: vizialisation library based on osg
 vizialisation library based on osg

=== debian/rules ===
#!/usr/bin/make -f

# BEGIN ENVIRONMENT SETUP
# https://www.debian.org/doc/debian-policy/ch-source.html
# nocheck: This tag says to not run any build-time test suite provided by the package.
export DEB_BUILD_OPTIONS=nocheck

# Setup of $(arch), $(rockruby_libdir) and $(rockruby_archdir)
arch=$(shell gcc -print-multiarch)
ruby_ver=$(shell ruby --version)
ruby_arch_dir=$(shell ruby -r rbconfig -e "print RbConfig::CONFIG['archdir']")
ruby_libdir=$(shell ruby -r rbconfig -e "print RbConfig::CONFIG['rubylibdir']")
rockruby_archdir=$(subst /usr,,$(ruby_arch_dir))
rockruby_libdir=$(subst /usr,,$(ruby_libdir))
# Setup of paths: PATH,PKG_CONFIG_PATH,RUBYLIB,...
master1906_install_dir = /opt/rock/master-19.06
env_setup =  PATH=$(master1906_install_dir)/bin:$(PATH)
env_setup += RUBYLIB=$(master1906_install_dir)/$(rockruby_libdir):$(master1906_install_dir)/$(rockruby_archdir):$(master1906_install_dir)/lib/ruby/vendor_ruby/standard:$(master1906_install_dir)/lib/ruby/vendor_ruby/core:$(master1906_install_dir)/lib/ruby/vendor_ruby:$(RUBYLIB)
env_setup += PKG_CONFIG_PATH=$(master1906_install_dir)/lib/pkgconfig:$(master1906_install_dir)/lib/$(arch)/pkgconfig:/usr/share/pkgconfig:/usr/lib/$(arch)/pkgconfig:$(PKG_CONFIG_PATH)
env_setup += Rock_DIR=$(master1906_install_dir)/share/rock/cmake:$(Rock_DIR)
env_setup += LD_LIBRARY_PATH=$(master1906_install_dir)/lib:$(master1906_install_dir)/lib/$(arch):$(LD_LIBRARY_PATH)
env_setup += CMAKE_PREFIX_PATH=$(master1906_install_dir):$(CMAKE_PREFIX_PATH)
env_setup += OROGEN_PLUGIN_PATH=$(master1906_install_dir)/share/orogen/plugins:$(OROGEN_PLUGIN_PATH)
export TYPELIB_CXX_LOADER=castxml
export DEB_CPPFLAGS_APPEND=-std=c++11
export npm_config_cache=/tmp/npm
rock_library_dirs=$(master1906_install_dir)/lib:$(master1906_install_dir)/lib/$(arch):
rock_install_dir=/opt/rock/master-19.06
# Check if a python command is available and identify the version
# and identify the setup.py file
python_cmd=$(shell command -v python 2> /dev/null)
ifneq ("$(python_cmd)","")
python_version=$(shell python -c 'import sys; print "{0}.{1}".format(sys.version_info[0],sys.version_info[1])')
# Get dirname a setup.py match
python_setup_dir=$(shell find $(DEB_SRCDIR) -name setup.py | tail -n 1 | xargs dirname)
endif

DEB_VERBOSE_ALL=1
include /usr/share/cdbs/1/rules/debhelper.mk
extra_lib_dir=$(shell pwd)/debian/rock-master-19.06-gui-osgviz$(rock_install_dir)/lib
# This argument list is forwarded to dh_shlibdeps which takes the -l option and a colon separated list of libraries
# (not that this is different from the linker arguments)
DEB_DH_SHLIBDEPS_ARGS_ALL=-l$(extra_lib_dir):$(extra_lib_dir)/$(arch):$(rock_library_dirs)

rock_doc_install_dir=$(rock_install_dir)/share/doc/rock-master-19.06-gui-osgviz

pre-build::
	echo "Detected:"
	echo "   ruby version: $(ruby_ver)"
	echo "   ruby libdir: $(rockruby_libdir)"
	echo "   ruby archdir: $(rockruby_archdir)"

	#echo "Current directory:"
	#find .

# END ENVIRONMENT SETUP
######################################
# BEGIN OROGEN -- This block needs to be executed before CMAKE


# END OROGEN
######################################
# BEGIN CMAKE
#
# Defining the cmake command and setting the required enviroment variables
# PKG_CONFIG_PATH Resolve Rock package via pkg-config
# Rock_DIR Set to make sure find_package(Rock) does work
# ROCK_CMAKE_MACROS Used in some patches to set the CMAKE_MODULE_PATH, allowing to find Rock.cmake
CMAKE = $(env_setup) cmake
DEB_CMAKE_INSTALL_PREFIX = $(rock_install_dir)

# Debian packaging discourages the use of rpath, but
# cdbs actively sets CMAKE_SKIP_RPATH=ON, so reinforcing OFF here
DEB_CMAKE_EXTRA_FLAGS = -DCMAKE_SKIP_RPATH=OFF
# Telling FindGEM.cmake to search for os packages using pkg-config and not for gems
DEB_CMAKE_EXTRA_FLAGS += -DGEM_OS_PKG=TRUE
# Leaving RUBY_EXECUTABLE unset since it maps to a path of the user executing the upload script
DEB_CMAKE_EXTRA_FLAGS +=  -DCMAKE_EXPORT_COMPILE_COMMANDS="ON"  -DROCK_USE_CXX11="ON"
# Disable ROCK Testing -- since running test on the OBS would require proper setting of path, etc. (see. data_processing/type_to_vector)
DEB_CMAKE_EXTRA_FLAGS += -DROCK_TEST_ENABLED=OFF -UROCK_TEST_LOG_DIR
include /usr/share/cdbs/1/class/cmake.mk

# END CMAKE
##########################################
# BEGIN AUTOTOOLS
#


# http://cdbs-doc.duckcorp.org/en/cdbs-doc.xhtml see post-configure actions
# replace all entries of -I with -I and -isystem in order to 
#   (a) guarantee that pkgconfig can still knowns the include directory (-I)
#   (b) the include directory is actually accounted for as system include directory (-isystem)
# Account for the fact, that configure is called multiple times e.g. revert changes first, then reapply
configure/rock-master-19.06-gui-osgviz::
	echo "Adapt -I to -isystem in pkgconfig files:"
	find . -name '[a-zA-Z]*.pc' -exec sh -c "echo Adapting {}; sed -i 's#\(\"\?\)-isystem[^ ]\+\1##g; s#\(\"\?\)-I\([^ ]\+\)\1#\1-I\2\1 \1-isystem\2\1#g; s#[ ]\+# #g' {}; cat {};" \;

###########################################
# DOCS


# Build docs
# This checks for Doxyfile and runs doxygen with that.
# Otherwise, it tries the "doc" target.
# Since docs are not critical, ignore failures('-' on recipe line start).
# The make call is supposed to be invoked even if -t or -n is selected,
# with the appropriate flags('+' on recipe line start)

common-build-arch common-build-indep:: debian/stamp-rock-doc
debian/stamp-rock-doc:
	-+$(DEB_MAKE_INVOKE) doc
	touch $@

common-install-arch common-install-indep:: common-install-rock-doc install-extensions
common-install-rock-doc::
	mkdir -p $(DEB_DESTDIR)$(rock_doc_install_dir)
	$(if $(wildcard $(DEB_SRCDIR)/doc/html),-cp -r "$(DEB_SRCDIR)/doc/html" "$(DEB_DESTDIR)$(rock_doc_install_dir)",$(if $(wildcard $(DEB_SRCDIR)/doc),-cp -r "$(DEB_SRCDIR)/doc" "$(DEB_DESTDIR)$(rock_doc_install_dir)"))
	$(if $(wildcard $(DEB_BUILDDIR)/doc/html),-cp -r "$(DEB_BUILDDIR)/doc/html" "$(DEB_DESTDIR)$(rock_doc_install_dir)",$(if $(wildcard $(DEB_BUILDDIR)/doc),-cp -r "$(DEB_BUILDDIR)/doc" "$(DEB_DESTDIR)$(rock_doc_install_dir)"))

install-extensions:: install-python
install-python::
ifneq ("$(python_setup_dir)","")
	echo "Installing python extension in $(python_setup_dir)"
	mkdir -p $(DEB_DESTDIR)$(rock_install_dir)/lib/python$(python_version)/site-packages
	cd $(python_setup_dir); $(python_cmd) setup.py build; PYTHONPATH=$(DEB_DESTDIR)$(rock_install_dir)/lib/python$(python_version)/site-packages/ $(python_cmd) setup.py install --prefix=$(DEB_DESTDIR)$(rock_install_dir); cd -
endif

clean::
	rm -f debian/stamp-rock-doc
	rm -rf $(DEB_SRCDIR)/doc/html


# END DOCS
###########################################
